;(function($){
	
	ZSelect=function(cfg){
		/*
			cfg:{
				label:"左边显示的标签",
				value:"默认值",
				element:obj
			}
		*/
		ZEvent.call(this);
		var _th=this;
		this.cfg=cfg;
		var html='<span class="hg-label hg-label-l">'+cfg.label+'</span>'+
			 '<span class="hg-select-value hg-text"></span>'+
			 '<span class="hg-iconfont hg-iconfont-rarrow"></span>';
		var ele=$(cfg.element);
		ele.addClass('hg-select');
		ele.prepend(html);
		this.set(cfg.value);
		ele.on('change','select',function(){
			var v=$(this).val();
			_th.set(v);
		});
	}
	hg.inheritPrototype(ZSelect,ZEvent);
	ZSelect.prototype.set = function(val){
		var ele=$(this.cfg.element);
		var s=ele.find('select');
		if(!val){
			val=s.val();
		}
		s.val(val);
		var text=s.find('option:checked').html();
		ele.find('.hg-select-value').html(text);
		this.trigger({
			name:'change',
			value:val,
			element:$(this.cfg.element).find('select')
		});
	}

	ZSelect.prototype.unshiftOption=function(obj){
		/*obj:{
			name:'',
			value''
		}*/
		var ele = $(this.cfg.element);
		var s = ele.find('select');
		var o = ele.find('option[value='+obj.value+']');
		if(o.length==0){
			var str = '<option value="'+obj.value+'">'+obj.name+'</option>';
			o = $(str);
			s.prepend(o);
		}
		return o;
	}

	ZSelect.prototype.shiftOption=function(val){
		var ele = $(this.cfg.element);
		var s = ele.find('select');

		var oldVal = s.val();
		s.find('option[value='+val+']').remove();

		if(oldVal==val){
			var target = s.find('option:first').attr('value');
			this.set(target);
		}
		
	}
	ZSelect.prototype.getElement=function(){
		return this.cfg.element;
	}

	$.fn.mkSelect = function(cfg) {
    	cfg.element=this;
    	return new ZSelect(cfg);
    };
})($);